#include "driver/gpio.h"
#include "driver/i2c.h"
#define ACK_CHECK_EN 0x1            /*!< I2C master will check ack from slave*/
#define ACK_CHECK_DIS 0x0           /*!< I2C master will not check ack from slave */
#define ACK_VAL 0x0                 /*!< I2C ack value */
#define NACK_VAL 0x1

//register A value
static const uint8_t SAMPLE_NUM_1 = 0x00;
static const uint8_t SAMPLE_NUM_2 = 0x01;
static const uint8_t SAMPLE_NUM_4 = (0x01 << 1);
static const uint8_t SAMPLE_NUM_8 = (0x01 << 1) | 1;
static const uint8_t DATA_RATE_0_75 = 0;
static const uint8_t DATA_RATE_1_5 = 1;
static const uint8_t DATA_RATE_3 = 1 << 1;
static const uint8_t DATA_RATE_7_5 = (1 << 1) | 1;
static const uint8_t DATA_RATE_15 = 1 << 2;
static const uint8_t DATA_RATE_30 = (1 << 2) | 1;
static const uint8_t DATA_RATE_75 = (1 << 2) | (1 << 1);
//register B value
static const uint8_t GAIN_1370 = 0;
static const uint8_t GAIN_1090 = 1;
static const uint8_t GAIN_820 = 2;
static const uint8_t GAIN_660 = 3;
static const uint8_t GAIN_440 = 4;
static const uint8_t GAIN_390 = 5;
static const uint8_t GAIN_330 = 6;
static const uint8_t GAIN_230 = 7;
static const uint8_t GAIN_BITS[8] = { GAIN_1370, GAIN_1090, GAIN_820, GAIN_660,
		GAIN_440, GAIN_390, GAIN_330, GAIN_230 };
static const int GAINS[8] = { 1370, 1090, 820, 660, 440, 390, 330, 230 };

static const uint8_t CHIP_ADDR = 0x1e;
static const uint8_t CHIP_ADDR_WRITE = (CHIP_ADDR << 1) | I2C_MASTER_WRITE;
static const uint8_t CHIP_ADDR_READ = (CHIP_ADDR << 1) | I2C_MASTER_READ;
static const uint8_t CA_REG_ADDR = 0x00;
static const uint8_t CB_REG_ADDR = 0x01;
static const uint8_t MODE_REG_ADDR = 0x02;
static const uint8_t XZY_REG_ADDRS[6] = { 3, 4, 5, 6, 7, 8 };

typedef void (*FP_AXIS_READ)(uint16_t rx, uint16_t ry, uint16_t rz, float x,
		float y, float z);
void init_compass();
void compass_task(void*);
