#ifndef COMPONENTS_DISPLAY_INCLUDE_DISPLAY_H_
#define COMPONENTS_DISPLAY_INCLUDE_DISPLAY_H_
#define SPI2_SCK 22
#define SPI2_MOSI 21
#define SPI2_MISO 27
#define LCD_SPI_CS_PIN 5
#define LCD_SPI_DC_PIN 17
#define LCD_SPI_RESET_PIN 4
#define LCD_SPI_BL_PIN 23
#define LCD_SPI_CLOCK_FREQ 20000000
#define MAX_DISPLAY_MSG_SIZE sizeof(float)*3
#define	TYPE_COMPASS_READ 0
#define TYPE_MENU_NAVIGATE 1
#define COMPASS_PADDING 15
#define COMPASS_CENTER_X 40
#define COMPASS_CENTER_Y 40
#define COMPASS_RADIUS 40
#define NEEDLE_LENGTH 35
#define BRIGHT_RED LV_COLOR_MAKE(0xFF, 0x00, 0x00)
#define SHOW_PANEL 1
#define HIDE_PANEL 0
#define MAINTAIN_PAGE 2
#define NEXT_ITEM 1
#define PREV_ITEM -1
#define MAINTAIN_ITEM 0
#define SELECT_ITEM 2
typedef struct {
	uint8_t type;
	char msg[MAX_DISPLAY_MSG_SIZE];
	uint16_t rx;
	uint16_t ry;
	uint16_t rz;
	float x;
	float y;
	float z;
	float theta;
	int8_t page_action;
	int8_t item_action;
	size_t msg_len;
} DisplayMsg;
typedef void (*FP_MENU_PANEL)(int8_t state, int8_t item_index);
void init_display();
void display_task(void*);
void create_compass();
void create_compass_label();
void create_reading_label();
void main_page();
void compute_end_point();
void create_menu();
#endif
