/*
 * main_menu.c
 *
 *  Created on: 2021年12月10日
 *      Author: xy
 */
#include <stdio.h>
#include "display.h"
#include "main_menu.h"
#include "lvgl_gui.h"
static int8_t current_page_act;
static uint8_t inited;
static lv_obj_t *label[MAIN_ITEM_LEN];
static lv_obj_t *cursor;
static lv_obj_t *title;
static uint8_t item_index;
static const char *TAG = "MAINPAGE";
void init_main_menu() {
	ESP_LOGI(TAG, "Initializing...");
	char *items[MAIN_ITEM_LEN] = { "Calibrate", "Restart" };
	cursor = lv_label_create(lv_scr_act(), NULL);
	lv_label_set_text(cursor, ">");
	title = lv_label_create(lv_scr_act(), NULL);
	lv_label_set_text(title, "Main");
	lv_obj_align(title, NULL, LV_ALIGN_IN_TOP_LEFT, 155, 120);
	for (uint8_t i = 0; i < MAIN_ITEM_LEN; i++) {
		label[i] = lv_label_create(lv_scr_act(), NULL);
		lv_label_set_text(label[i], items[i]);
		lv_obj_align(label[i], NULL, LV_ALIGN_IN_TOP_LEFT, 155, 140 + 20 * i);
	}
	inited = 1;
}

void main_menu_panel(int8_t page_act, int8_t item_act) {
	if (page_act != MAINTAIN_PAGE)
		current_page_act = page_act;
	if (current_page_act == SHOW_PANEL) {
		if (!inited) {
			ESP_LOGI(TAG, "Menu not inited...");
			return;
		}
		if (item_act != SELECT_ITEM) {
			item_index =
					(MAIN_ITEM_LEN + item_index + item_act) % MAIN_ITEM_LEN;
		} else {
			ESP_LOGI(TAG, "Handle key press on index:%u", item_index);
			return;
		}
		lv_obj_align(cursor, NULL, LV_ALIGN_IN_TOP_LEFT, 140,
				140 + item_index * 20);
		lv_obj_set_hidden(title, false);
		lv_obj_set_hidden(cursor, false);
		for (uint8_t i = 0; i < MAIN_ITEM_LEN; i++)
			lv_obj_set_hidden(label[0], false);
		return;
	}
	if (current_page_act == HIDE_PANEL) {
		if (!inited)
			return;
		lv_obj_set_hidden(title, true);
		lv_obj_set_hidden(cursor, true);
		for (uint8_t i = 0; i < MAIN_ITEM_LEN; i++)
			lv_obj_set_hidden(label[i], true);
	}
}

